<template>
  <div>
    <h1>Registration Form</h1>
    <Form @submit="onSubmit">
      <div>
        <label for="username">Username</label>
        <Field name="username" as="input" type="text" />
        <ErrorMessage name="username" />
      </div>

      <div>
        <label for="email">Email</label>
        <Field name="email" as="input" type="email" />
        <ErrorMessage name="email" />
      </div>

      <div>
        <label for="password">Password</label>
        <Field name="password" as="input" type="password" />
        <ErrorMessage name="password" />
      </div>

      <button type="submit">Register</button>
    </Form>
  </div>
</template>

<script>
import { defineComponent } from 'vue';
import { Form, Field, ErrorMessage } from 'vee-validate';
import * as yup from 'yup';

export default defineComponent({
  components: {ErrorMessage, Form, Field},
  setup() {
    const schema = yup.object({
      username: yup.string().required('Username is required'),
      email: yup.string().email('Invalid email format').required('Email is required'),
      password: yup.string().min(6, 'Password must be at least 6 characters').required('Password is required'),
    });

    const onSubmit = async (values, { setErrors }) => {
      try {
        // Mock server-side validation
        const response = await fakeApiRequest(values);
        if (response.error) {
          setErrors(response.error);
        } else {
          alert('Registration successful!');
        }
      } catch (error) {
        console.error('Server error', error);
      }
    };

    const fakeApiRequest = (values) => {
      return new Promise((resolve) => {
        setTimeout(() => {
          if (values.username === 'existinguser') {
            resolve({ error: { username: 'Username already taken' } });
          } else {
            resolve({});
          }
        }, 1000);
      });
    };

    return {
      schema,
      onSubmit,
    };
  },
});
</script>

<style scoped>
/* Add your styles here */
</style>
